#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
#include <DFPlayerMini.h>
#include <FastLED.h>
#include <CapacitiveSensor.h>


#define LED_PIN     8
#define LED_PIN2    6
#define COLOR_ORDER GRB
#define CHIPSET     WS2811
#define NUM_LEDS    64


int BRIGHTNESS = 0;
#define FRAMES_PER_SECOND 100

bool gReverseDirection = false;

bool ON = true; //is the system on or off?
bool SOUND = false; //if true, the volume can be changed
bool BRI = false;
int mode = 0; //fire or water?
int timerButt = 0; //timer for the long press to switch OFF
int IRTimer = 0; //timer for the long IR activation
int IRTimer2 = 0; //timer for the long IR activation, brightness side
unsigned long prevSensButt = 0;
unsigned long sensButt;
unsigned long averSensButt;
unsigned long prevAverSensButt;
int capteur1 = 0;
int capteur2 = 0;
short prevMode = 0;
int COOLING = 160;
int SETCOOLING =55;
int SPARKING = 80;
int SPARKMULTI = 0;
unsigned long timerOFF = 0;
unsigned long timerIR = 0;
unsigned long timerIRcadance = 0;

CRGB leds[NUM_LEDS];
CRGB leds2[NUM_LEDS];
CRGBPalette16 gPal;


SoftwareSerial mySoftwareSerial(3, 2); // RX, TX
DFRobotDFPlayerMini myDFPlayer;
//DFPlayerMini myDFPlayer;
void printDetail(uint8_t type, int value);

CapacitiveSensor   cs = CapacitiveSensor(10, 11);       // 1M resistor between pins 10 & 11, pin 11is sensor pin

//CRGBPalette16 waterPalette;
CRGB Blu1 = CHSV( 135, 255, 225);
CRGB Blu2  = CHSV( 155, 185, 255);
CRGB Blu3  = CHSV( 170, 255, 180);
CRGB black  = CRGB::Black;
CRGB whi = CHSV(0, 0, 255);

void setup()
{
  mySoftwareSerial.begin(9600);
  Serial.begin(115200);

  FastLED.addLeds<CHIPSET, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.addLeds<CHIPSET, LED_PIN2, COLOR_ORDER>(leds2, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.setBrightness( BRIGHTNESS );

  //gPal = HeatColors_p;
  //gPal = OceanColors_p;

  Serial.println();
  Serial.println(F("DFRobot DFPlayer Mini Demo"));
  Serial.println(F("Initializing DFPlayer ... (May take 3~5 seconds)"));

  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while (true);
  }
  Serial.println(F("DFPlayer Mini online."));

  myDFPlayer.volume(4);  //Set volume value. From 0 to 30
  myDFPlayer.play(3);  //Play the first mp3
  myDFPlayer.enableLoop();

  //cs.set_CS_AutocaL_Millis(0xFFFFFFFF);
}

void loop()
{

  //////////////////////////////// MODE / POWER BUTTON /////////////////////////////////

//  Serial.print("mode = ");
//  Serial.print(mode);
//  Serial.print("\t");
//  Serial.print("sensButt = ");
//  Serial.print(sensButt);
//  Serial.print("\t");
//  Serial.print("averSensButt = ");
//  Serial.print(averSensButt);
//  Serial.print("\t");
//  Serial.print("ON? -> ");
//  Serial.println(ON);

  if (mode == 0) {
    gPal = HeatColors_p;
    gReverseDirection = false;
    if (prevMode != mode) {
      myDFPlayer.EQ(DFPLAYER_EQ_POP);
      delay(70);
      myDFPlayer.loop(3);
      delay(20);
      SETCOOLING = 55;
      SPARKING = 80;
      Serial.print("CHANGING FOR FIRE");
    }
  }
  if (mode == 1) {
    //gPal = OceanColors_p;
    gPal = CRGBPalette16(
             Blu3,  Blu2,  Blu1,  Blu1,
             Blu1, Blu1, whi,  Blu1,
             Blu2,  black,  Blu3,  black,
             black, black, black,  black );
    gReverseDirection = true;
    if (prevMode != mode) {
      myDFPlayer.EQ(DFPLAYER_EQ_BASS);
      //myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
      //  myDFPlayer.EQ(DFPLAYER_EQ_POP);
      //  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
      //  myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);
      //  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
      //  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
      delay(70);
      myDFPlayer.loop(2);
      delay(20);
      SETCOOLING = 40;
      SPARKING = 100;
      Serial.print("CHANGING FOR WATER");
    }
  }

  if (ON == true && COOLING != SETCOOLING) {
    if (timerOFF + 100 < millis()) {
      timerOFF = millis();
      if (COOLING > SETCOOLING) {
        COOLING--;
      }
      if (COOLING < SETCOOLING) {
        COOLING++;
      }
      
      if (BRIGHTNESS < 55) {
        BRIGHTNESS++;
        FastLED.setBrightness( BRIGHTNESS );
        if (BRIGHTNESS == 1) {
          myDFPlayer.volume(4);
        }
      }
    }
  }

  if (ON == false) {
    if (timerOFF + 100 < millis()) {
      timerOFF = millis();
      if (COOLING < 350) {
        //SPARKMULTI++;
        COOLING += 2;
      }
      if (BRIGHTNESS > 0) {
        BRIGHTNESS--;
        FastLED.setBrightness( BRIGHTNESS );
        if (BRIGHTNESS == 1) {
          myDFPlayer.volume(0);
        }
      }
    }
  }

  sensButt =  cs.capacitiveSensor(2);

  averSensButt =  (sensButt + prevSensButt) / 2;

  prevMode = mode;

  if (averSensButt < 18 && prevAverSensButt > 18 && timerButt < 39 ) { //drop in the sensing button within a short period press
    mode++;
    if (mode > 1) {
      mode = 0;
    }
  }

  if (averSensButt > 18) {
    timerButt++;
    IRTimer = 0;
    IRTimer2 = 0;
  }

  if (timerButt > 40 && averSensButt < 18) {
    ON = !ON;
  }

  if (timerButt > 0 && averSensButt < 18) {
    timerButt = 0;
  }

  prevSensButt = sensButt;
  prevAverSensButt = averSensButt;

  //////////////////////////////// MODE / POWER BUTTON END /////////////////////////////////

  capteur1 = analogRead(A0);
  capteur1 = map(capteur1, 33, 400, 0, 15);
  capteur1 = constrain(capteur1, 0, 15);

  capteur2 = analogRead(A7);

Serial.print("capteur1 =  ");
    Serial.print(capteur1);
    Serial.print("\t");
    Serial.print("capteur2 =  ");
    Serial.println(capteur2);

 if (averSensButt < 18 && BRI == false && capteur2 <=33) {
    IRTimer2++;
    if (IRTimer2 >30) {
      BRI = true;
      IRTimer2 = 0;
      timerIR = millis();
    }
  }


  if(capteur2>33){
    IRTimer2 = 0;
  }

  if (mode == 0) {
    capteur2 = map(capteur2, 33, 150, 3, 55);
    capteur2 = constrain(capteur2, 3, 55);
  }

  if (mode == 1) {
    capteur2 = map(capteur2, 33, 150, 5, 55);
    capteur2 = constrain(capteur2, 5, 55);
  }

  if (averSensButt < 18 && SOUND == false && capteur1 == 0) {
    IRTimer++;
    if (IRTimer > 30) {
      SOUND = true;
      IRTimer = 0;
      timerIR = millis();
    }
  }

  if(capteur1>0){
    IRTimer = 0;
  }


  // Add entropy to random number generator; we use a lot of it.
  random16_add_entropy( random());

  // Fourth, the most sophisticated: this one sets up a new palette every
  // time through the loop, based on a hue that changes every time.
  // The palette is a gradient from black, to a dark color based on the hue,
  // to a light color based on the hue, to white.
  //
  //   static uint8_t hue = 0;
  //   hue++;
  //   CRGB darkcolor  = CHSV(hue,255,192); // pure hue, three-quarters brightness
  //   CRGB lightcolor = CHSV(hue,128,255); // half 'whitened', full brightness
  //   gPal = CRGBPalette16( CRGB::Black, darkcolor, lightcolor, CRGB::White);


  Fire2012WithPalette(); // run simulation frame, using palette colors


  if (SOUND == true) {
    leds[NUM_LEDS - 17 + capteur1 - 1] = CHSV(0, 255, 0);
    leds[NUM_LEDS - 17 + capteur1 + 1] = CHSV(0, 255, 0);
    leds2[NUM_LEDS - 17 + capteur1 - 1] = CHSV(0, 255, 0);
    leds2[NUM_LEDS - 17 + capteur1 + 1] = CHSV(0, 255, 0);

    if(mode==0){
    leds[NUM_LEDS - 17 + capteur1] = CHSV(180 - capteur1 * 2, 255 - capteur1 * 6, 255);
    leds2[NUM_LEDS - 17 + capteur1] = CHSV(160 - capteur1, 255 - capteur1 * 5, 255);
    }

    if(mode==1){
    leds[NUM_LEDS - 17 + capteur1] = CHSV(50 - capteur1 * 2, 255, 255);
    leds2[NUM_LEDS - 17 + capteur1] = CHSV(16 - capteur1, 255, 255);
    }
    
 if (timerIRcadance + 550 < millis()) {
      timerIRcadance = millis();
      if(mode==0){
 myDFPlayer.volume(capteur1*2);
      }
      if(mode==1){
 myDFPlayer.volume(capteur1);
      }
 }
  
    if (timerIR + 3000 < millis()) {
      SOUND = false;
    }
  }

  if (BRI == true) {
     if(mode==0){
    leds[NUM_LEDS-1] = CHSV(150, 255, 255);
    leds2[NUM_LEDS-1] = CHSV(125, 255, 255);
    leds[NUM_LEDS-2] = CHSV(150, 255, 255);
    leds2[NUM_LEDS-2] = CHSV(125, 255, 255);
     }
     if(mode==1){
    leds[NUM_LEDS-1] = CHSV(20, 255, 255);
    leds2[NUM_LEDS-1] = CHSV(0, 255, 255);
    leds[NUM_LEDS-2] = CHSV(20, 255, 255);
    leds2[NUM_LEDS-2] = CHSV(0, 255, 255);
     }
       BRIGHTNESS=capteur2;
         FastLED.setBrightness( BRIGHTNESS );
   
    if (timerIR + 3000 < millis()) {
      BRI = false;
    }
  }



  FastLED.show(); // display this frame
  FastLED.delay(1000 / FRAMES_PER_SECOND);

}

// Fire2012 by Mark Kriegsman, July 2012
// as part of "Five Elements" shown here: http://youtu.be/knWiGsmgycY
////
// This basic one-dimensional 'fire' simulation works roughly as follows:
// There's a underlying array of 'heat' cells, that model the temperature
// at each point along the line.  Every cycle through the simulation,
// four steps are performed:
//  1) All cells cool down a little bit, losing heat to the air
//  2) The heat from each cell drifts 'up' and diffuses a little
//  3) Sometimes randomly new 'sparks' of heat are added at the bottom
//  4) The heat from each cell is rendered as a color into the leds array
//     The heat-to-color mapping uses a black-body radiation approximation.
//
// Temperature is in arbitrary units from 0 (cold black) to 255 (white hot).
//
// This simulation scales it self a bit depending on NUM_LEDS; it should look
// "OK" on anywhere from 20 to 100 LEDs without too much tweaking.
//
// I recommend running this simulation at anywhere from 30-100 frames per second,
// meaning an interframe delay of about 10-35 milliseconds.
//
// Looks best on a high-density LED setup (60+ pixels/meter).
//
//
// There are two main parameters you can play with to control the look and
// feel of your fire: COOLING (used in step 1 above), and SPARKING (used
// in step 3 above).
//
// COOLING: How much does the air cool as it rises?
// Less cooling = taller flames.  More cooling = shorter flames.
// Default 55, suggested range 20-100
//int COOLING = 55;

// SPARKING: What chance (out of 255) is there that a new spark will be lit?
// Higher chance = more roaring fire.  Lower chance = more flickery fire.
// Default 120, suggested range 50-200.
//#define SPARKING 80


void Fire2012WithPalette()
{
  // Array of temperature readings at each simulation cell
  static byte heat[NUM_LEDS];
  static byte heat2[NUM_LEDS];

  // Step 1.  Cool down every cell a little
  for ( int i = 0; i < NUM_LEDS; i++) {
    heat[i] = qsub8( heat[i],  random8(0, ((COOLING * 10) / NUM_LEDS) + 2));
    heat2[i] = qsub8( heat2[i],  random8(0, ((COOLING * 10) / NUM_LEDS) + 2));
  }

  // Step 2.  Heat from each cell drifts 'up' and diffuses a little
  for ( int k = NUM_LEDS - 1; k >= 2; k--) {
    heat[k] = (heat[k - 1] + heat[k - 2] + heat[k - 2] ) / 3;
    heat2[k] = (heat2[k - 1] + heat2[k - 2] + heat2[k - 2] ) / 3;
  }

  // Step 3.  Randomly ignite new 'sparks' of heat near the bottom
  if ( random8() < SPARKING ) {
    int y = random8(7);
    heat[y] = qadd8( heat[y], random8(160, 255) );
  }
  random16_add_entropy( random());
  if ( random8() < SPARKING - 40 ) {
    int y = random8(7);
    heat2[y] = qadd8( heat2[y], random8(100, 200) );
  }

  // Step 4.  Map from heat cells to LED colors
  for ( int j = 0; j < NUM_LEDS; j++) {
    // Scale the heat value from 0-255 down to 0-240
    // for best results with color palettes.
    byte colorindex = scale8( heat[j], 240);
    byte colorindex2 = scale8( heat2[j], 240);

    CRGB color = ColorFromPalette( gPal, colorindex);
    CRGB color2 = ColorFromPalette( gPal, colorindex2);
    int pixelnumber;
    if ( gReverseDirection ) {
      pixelnumber = (NUM_LEDS - 1) - j;
    } else {
      pixelnumber = j;
    }
    leds[pixelnumber] = color;
    leds2[pixelnumber] = color2;
  }
}


void printDetail(uint8_t type, int value) {
  switch (type) {
    case TimeOut:
      Serial.println(F("Time Out!"));
      break;
    case WrongStack:
      Serial.println(F("Stack Wrong!"));
      break;
    case DFPlayerCardInserted:
      Serial.println(F("Card Inserted!"));
      break;
    case DFPlayerCardRemoved:
      Serial.println(F("Card Removed!"));
      break;
    case DFPlayerCardOnline:
      Serial.println(F("Card Online!"));
      break;
    case DFPlayerPlayFinished:
      Serial.print(F("Number:"));
      Serial.print(value);
      Serial.println(F(" Play Finished!"));
      break;
    case DFPlayerError:
      Serial.print(F("DFPlayerError:"));
      switch (value) {
        case Busy:
          Serial.println(F("Card not found"));
          break;
        case Sleeping:
          Serial.println(F("Sleeping"));
          break;
        case SerialWrongStack:
          Serial.println(F("Get Wrong Stack"));
          break;
        case CheckSumNotMatch:
          Serial.println(F("Check Sum Not Match"));
          break;
        case FileIndexOut:
          Serial.println(F("File Index Out of Bound"));
          break;
        case FileMismatch:
          Serial.println(F("Cannot Find File"));
          break;
        case Advertise:
          Serial.println(F("In Advertise"));
          break;
        default:
          break;
      }
      break;
    default:
      break;
  }

}
